--- libgui/src/octave-dock-widget.cc.orig	2016-10-27 11:48:37.000000000 -0700
+++ libgui/src/octave-dock-widget.cc	2016-11-10 04:08:42.000000000 -0700
@@ -55,8 +55,13 @@
            this, SLOT (handle_active_dock_changed (octave_dock_widget*,
                                                    octave_dock_widget*)));
 
-  QStyle *st = style ();
-  m_icon_size = 0.75*st->pixelMetric (QStyle::PM_SmallIconSize);
+  QStyle *st = p->style ();
+#if defined (Q_OS_MAC)
+  // fix retina scaling for Mac (bug #46723)
+  m_icon_size = 2*st->pixelMetric (QStyle::PM_SmallIconSize) / p->devicePixelRatio();
+#else
+  m_icon_size = st->pixelMetric (QStyle::PM_SmallIconSize);
+#endif
 
 #if defined (Q_OS_WIN32)
   // windows: add an extra title bar that persists when floating
